diff --git a/src/main/java/net/minecraft/core/block/GlowStoneBlock.java b/src/main/java/net/minecraft/core/block/BlockGlowStone.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/GlowStoneBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGlowStone.java
index ecf0302ae..106033879 100644
--- a/src/main/java/net/minecraft/core/block/GlowStoneBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGlowStone.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -11,16 +11,16 @@ import net.minecraft.core.world.WorldSource;
 // Referenced classes of package net.minecraft.src:
 //            Block, Item, Material
 
-public class GlowStoneBlock extends Block
+public class BlockGlowStone extends Block
 {
 
-    public GlowStoneBlock(String key, String namespaceId, int id, Material material)
+    public BlockGlowStone(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/GrassBlock.java b/src/main/java/net/minecraft/core/block/BlockGrass.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/GrassBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGrass.java
index 65b19040c..cd3067d3c 100644
--- a/src/main/java/net/minecraft/core/block/GrassBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGrass.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.enums.EnumDropCause;
@@ -16,11 +16,11 @@ import net.minecraft.core.world.noise.ImprovedNoise;
 //            Block, Material, IBlockAccess, WorldChunkManager, 
 //            ColorizerGrass, World
 
-public class GrassBlock extends Block
+public class BlockGrass extends Block
 {
     private static ImprovedNoise grassColorPerlin = new ImprovedNoise(new Random(0));
 
-    public GrassBlock(String key, String namespaceId, int id, Material material)
+    public BlockGrass(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setTicking(true);
@@ -83,7 +83,7 @@ public class GrassBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java b/src/main/java/net/minecraft/core/block/BlockGrassScorched.java
similarity index 76%
rename from src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGrassScorched.java
index 16759e0ec..9c7cf707a 100644
--- a/src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGrassScorched.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class ScorchedGrassBlock extends Block
+public class BlockGrassScorched extends Block
 {
-    public ScorchedGrassBlock(String key, String namespaceId, int id, Material material)
+    public BlockGrassScorched(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/GravelBlock.java b/src/main/java/net/minecraft/core/block/BlockGravel.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/GravelBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGravel.java
index 3bbad9999..0b1dd2b1d 100644
--- a/src/main/java/net/minecraft/core/block/GravelBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGravel.java
@@ -1,24 +1,24 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            SandBlock, Item
+//            BlockSand, Item
 
-public class GravelBlock extends SandBlock
+public class BlockGravel extends BlockSand
 {
 
-    public GravelBlock(String key, String namespaceId, int id)
+    public BlockGravel(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/IceBlock.java b/src/main/java/net/minecraft/core/block/BlockIce.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/IceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockIce.java
index 0feddf8a8..24802c980 100644
--- a/src/main/java/net/minecraft/core/block/IceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockIce.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -14,10 +14,10 @@ import java.util.Random;
 //            BlockBreakable, Material, World, Block, 
 //            EnumSkyBlock, IBlockAccess, Player
 
-public class IceBlock extends TransparentBlock
+public class BlockIce extends BlockTransparent
 {
 
-    public IceBlock(String key, String namespaceId, int id)
+    public BlockIce(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.ice);
         friction = 0.98F;
@@ -31,7 +31,7 @@ public class IceBlock extends TransparentBlock
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -44,9 +44,9 @@ public class IceBlock extends TransparentBlock
     }
 
     @Override
-    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, BlockEntity blockEntity)
+    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, TileEntity tileEntity)
     {
-        super.harvestBlock(world, entityplayer, x, y, z, meta, blockEntity);
+        super.harvestBlock(world, entityplayer, x, y, z, meta, tileEntity);
         Material material = world.getBlockMaterial(x, y - 1, z);
         if(material.blocksMotion() || material.isLiquid())
         {
diff --git a/src/main/java/net/minecraft/core/block/JarBlock.java b/src/main/java/net/minecraft/core/block/BlockJar.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/JarBlock.java
rename to src/main/java/net/minecraft/core/block/BlockJar.java
index c425fbfac..0c33182d7 100644
--- a/src/main/java/net/minecraft/core/block/JarBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockJar.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.FlowerJarBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -9,7 +9,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
@@ -18,10 +18,10 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public class JarBlock extends EntityBlock {
+public class BlockJar extends BlockTileEntity {
 
     private final Supplier<Item> itemSupplier;
-    public JarBlock(String key, String namespaceId, int id, @NotNull Supplier<Item> itemSupplier) {
+    public BlockJar(String key, String namespaceId, int id, @NotNull Supplier<Item> itemSupplier) {
         super(key, namespaceId, id, Material.glass);
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
         this.itemSupplier = itemSupplier;
@@ -77,7 +77,7 @@ public class JarBlock extends EntityBlock {
                     world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
                 }
             } else {
-                FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
+                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
                 int flowerInPot = tileEntity.flowerInPot;
                 int flowerData = tileEntity.flowerData;
                 if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
@@ -89,10 +89,10 @@ public class JarBlock extends EntityBlock {
                     }
                 }
             }
-        } else if (player.getHeldItem().getItem() instanceof BlockItem) {
-            Block blockInHand = ((BlockItem) player.getHeldItem().getItem()).getBlock();
+        } else if (player.getHeldItem().getItem() instanceof ItemBlock) {
+            Block blockInHand = ((ItemBlock) player.getHeldItem().getItem()).getBlock();
             if (hasTag(blockInHand.id, BlockTags.PLANTABLE_IN_JAR)) {
-                FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
+                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
                 if(world.getBlockMetadata(x, y, z) == 0) {
                     player.getHeldItem().consumeItem(player);
                     world.setBlockMetadataWithNotify(x, y, z, 1);
@@ -100,14 +100,14 @@ public class JarBlock extends EntityBlock {
                     tileEntity.flowerData = player.getHeldItem().getMetadata();
                     world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
                     return true;
-                } else if (blockInHand instanceof StackedFlowerBlock && blockInHand == Block.getBlock(tileEntity.flowerInPot)) {
+                } else if (blockInHand instanceof BlockFlowerStackable && blockInHand == Block.getBlock(tileEntity.flowerInPot)) {
                     final int metadata = tileEntity.flowerData;
-                    final int currentStackCount = StackedFlowerBlock.getStackCount(metadata);
-                    if (currentStackCount >= StackedFlowerBlock.MAX_STACK_COUNT) {
+                    final int currentStackCount = BlockFlowerStackable.getStackCount(metadata);
+                    if (currentStackCount >= BlockFlowerStackable.MAX_STACK_COUNT) {
                         return false;
                     }
 
-                    final int newMetadata = StackedFlowerBlock.setPermanent(StackedFlowerBlock.setStackCount(metadata, currentStackCount + 1), true);
+                    final int newMetadata = BlockFlowerStackable.setPermanent(BlockFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
                     tileEntity.flowerData = newMetadata;
                     world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
                     player.getHeldItem().consumeItem(player);
@@ -124,7 +124,7 @@ public class JarBlock extends EntityBlock {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -144,9 +144,9 @@ public class JarBlock extends EntityBlock {
     }
 
     @Override
-    protected BlockEntity getNewBlockEntity()
+    protected TileEntity getNewBlockEntity()
     {
-        return new FlowerJarBlockEntity();
+        return new TileEntityFlowerJar();
     }
 
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/JukeboxBlock.java b/src/main/java/net/minecraft/core/block/BlockJukebox.java
similarity index 61%
rename from src/main/java/net/minecraft/core/block/JukeboxBlock.java
rename to src/main/java/net/minecraft/core/block/BlockJukebox.java
index 48e354516..daed5484d 100644
--- a/src/main/java/net/minecraft/core/block/JukeboxBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockJukebox.java
@@ -1,24 +1,22 @@
 package net.minecraft.core.block;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, World, JukeboxBlockEntity,
-//            ItemEntity, ItemStack, Player, BlockEntity
+//            BlockContainer, Material, World, TileEntityJukebox,
+//            EntityItem, ItemStack, Player, TileEntity
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.JukeboxBlockEntity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityJukebox;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class JukeboxBlock extends EntityBlock
+public class BlockJukebox extends BlockTileEntity
 {
 
-	public JukeboxBlock(String key, String namespaceId, int id)
+	public BlockJukebox(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
@@ -37,7 +35,7 @@ public class JukeboxBlock extends EntityBlock
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         if (world.getBlockMetadata(x, y, z) != 0) {
             ejectRecord(world, x, y, z);
         }
@@ -46,7 +44,7 @@ public class JukeboxBlock extends EntityBlock
     public void playRecord(World world, int x, int y, int z, int recordId)
     {
         if (!world.isClientSide) {
-            JukeboxBlockEntity jukebox = (JukeboxBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntityJukebox jukebox = (TileEntityJukebox) world.getBlockEntity(x, y, z);
             jukebox.record = recordId;
             jukebox.setChanged();
             world.setBlockMetadataWithNotify(x, y, z, 1);
@@ -59,13 +57,13 @@ public class JukeboxBlock extends EntityBlock
         {
             return;
         }
-        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-        blockEntity.dropContents(world, x, y, z);
+        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        tileEntity.dropContents(world, x, y, z);
     }
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new JukeboxBlockEntity();
+        return new TileEntityJukebox();
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/LadderBlock.java b/src/main/java/net/minecraft/core/block/BlockLadder.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/LadderBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLadder.java
index a9bd3529a..e9da8c4f9 100644
--- a/src/main/java/net/minecraft/core/block/LadderBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLadder.java
@@ -7,9 +7,9 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class LadderBlock extends Block {
+public class BlockLadder extends Block {
 
-	public LadderBlock(String key, String namespaceId, int id) {
+	public BlockLadder(String key, String namespaceId, int id) {
 		super(key, namespaceId, id, Material.wood);
 	}
 	
@@ -55,13 +55,13 @@ public class LadderBlock extends Block {
 	
 	@Override
 	public final boolean canPlaceBlockAt(World world, int x, int y, int z) {
-		// Unused, check LadderBlockItem
+		// Unused, check ItemBlockLadder
 		return true;
 	}
 	
 	@Override
 	public final boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
-		// Unused, check LadderBlockItem
+		// Unused, check ItemBlockLadder
 		return true;
 	}
 	
diff --git a/src/main/java/net/minecraft/core/block/LampBlock.java b/src/main/java/net/minecraft/core/block/BlockLamp.java
similarity index 89%
rename from src/main/java/net/minecraft/core/block/LampBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLamp.java
index be09345f7..fb75a470b 100644
--- a/src/main/java/net/minecraft/core/block/LampBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLamp.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
@@ -10,10 +9,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class LampBlock extends Block implements IPainted {
+public class BlockLamp extends Block implements IPainted {
     public boolean isActive;
 
-    public LampBlock(String key, String namespaceId, int id, boolean isActivated) {
+    public BlockLamp(String key, String namespaceId, int id, boolean isActivated) {
         super(key, namespaceId, id, Material.stone);
         isActive = isActivated;
     }
@@ -45,7 +44,7 @@ public class LampBlock extends Block implements IPainted {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         return new ItemStack[]{new ItemStack(Blocks.LAMP_IDLE, 1, meta)};
     }
 
diff --git a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
index 442091669..553e2f079 100644
--- a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -18,13 +17,13 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Random;
 import java.util.function.Supplier;
 
-public class FireflyLanternBlock extends Block{
+public class BlockLanternFirefly extends Block{
     public static final int MASK_HANGING = 0b0000_0001;
     public static final int MASK_ANGLED = 0b0000_0010;
     private final Supplier<Item> itemSupplier;
-    private final FireflyClusterMob.FireflyColor color;
+    private final MobFireflyCluster.FireflyColor color;
 
-    public FireflyLanternBlock(String key, String namespaceId, int id, FireflyClusterMob.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
+    public BlockLanternFirefly(String key, String namespaceId, int id, MobFireflyCluster.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
         super(key, namespaceId, id, Material.glass);
         this.color = colour;
         this.itemSupplier = itemSupplier;
@@ -129,7 +128,7 @@ public class FireflyLanternBlock extends Block{
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -159,7 +158,7 @@ public class FireflyLanternBlock extends Block{
     		return;
     	}
     	if(!world.isClientSide) {
-        	FireflyClusterMob entity = new FireflyClusterMob(world);
+        	MobFireflyCluster entity = new MobFireflyCluster(world);
         	entity.setColor(color);
         	entity.setFireflyCount(1);
         	entity.setClusterSize(0);
diff --git a/src/main/java/net/minecraft/core/block/BaseLayerBlock.java b/src/main/java/net/minecraft/core/block/BlockLayerBase.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BaseLayerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLayerBase.java
index 1fc4fe512..c5e64424f 100644
--- a/src/main/java/net/minecraft/core/block/BaseLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLayerBase.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.item.block.LayerBlockItem;
+import net.minecraft.core.item.block.ItemBlockLayer;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
@@ -9,20 +9,20 @@ import java.util.function.Supplier;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            IBlockAccess, Item, EntityItem, ItemStack,
 //            StatList, Player, EnumSkyBlock
 
-public abstract class BaseLayerBlock extends Block
+public abstract class BlockLayerBase extends Block
 {
     private Supplier<Integer> idSupplier = () -> -1;
 	
-	public BaseLayerBlock(String key, String namespaceId, int id, Material material)
+	public BlockLayerBase(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
-        setBlockItem(() -> new LayerBlockItem(this));
+        setBlockItem(() -> new ItemBlockLayer(this));
     }
-    public BaseLayerBlock setFullBlockID(Supplier<Integer> idSupplier)
+    public BlockLayerBase setFullBlockID(Supplier<Integer> idSupplier)
     {
     	this.idSupplier = idSupplier;
     	return this;
diff --git a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java b/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
index 1f18fead4..7e4d56ecc 100644
--- a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
@@ -13,14 +13,14 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            IBlockAccess, Item, EntityItem, ItemStack,
 //            StatList, Player, EnumSkyBlock
 
-public class LeavesLayerBlock extends BaseLayerBlock
+public class BlockLayerLeaves extends BlockLayerBase
 {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
-	public LeavesLayerBlock(String key, String namespaceId, int id, Material material)
+	public BlockLayerLeaves(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
@@ -55,7 +55,7 @@ public class LeavesLayerBlock extends BaseLayerBlock
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BaseLeavesBlock)))
+        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
         {
         	return false;
         }
@@ -78,7 +78,7 @@ public class LeavesLayerBlock extends BaseLayerBlock
 
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/SlateLayerBlock.java b/src/main/java/net/minecraft/core/block/BlockLayerSlate.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/SlateLayerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLayerSlate.java
index 7194a08f1..3305b34b2 100644
--- a/src/main/java/net/minecraft/core/block/SlateLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLayerSlate.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 
-public class SlateLayerBlock extends BaseLayerBlock
+public class BlockLayerSlate extends BlockLayerBase
 {
-	public SlateLayerBlock(String key, String namespaceId, int id, Material material)
+	public BlockLayerSlate(String key, String namespaceId, int id, Material material)
 	{
 		super(key, namespaceId, id, material);
 	}
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java b/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/SnowLayerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLayerSnow.java
index d8f08df6a..3849499c3 100644
--- a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -14,13 +14,13 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            IBlockAccess, Item, EntityItem, ItemStack,
 //            StatList, Player, EnumSkyBlock
 
-public class SnowLayerBlock extends BaseLayerBlock
+public class BlockLayerSnow extends BlockLayerBase
 {
 
-	public SnowLayerBlock(String key, String namespaceId, int id, Material material)
+	public BlockLayerSnow(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
@@ -57,7 +57,7 @@ public class SnowLayerBlock extends BaseLayerBlock
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BaseLeavesBlock)))
+        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
         {
         	return false;
         }
@@ -78,7 +78,7 @@ public class SnowLayerBlock extends BaseLayerBlock
         }
     }
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
